/*
  ###########################
        WORK IN PROGRESS
  ###########################
  Audio player, non blocking.
  read 8bit mono .wav file, up to 4 channels
  use Audacity to convert your audio file

  Author : AloyseTech
*/

#include <SdFat.h>
SdFat SD;
#include <SPI.h>
#include <SamdAudio.h>
SamdAudio AudioPlayer;

// which Serial you prefer, for information.
#define SERIAL SerialUSB
//#define SERIAL Serial

// SD chip select pin (with ethernet shield : 4)
#define YOUR_SD_CS 6

//your wav file
const char *filename = "test.wav";

//indicate sample rate here (use audacity to convert your wav)
const unsigned int sampleRate = 22050;

bool state = true;

uint32_t timer = 0, updatetimer = 0;

void setup()
{
  pinMode(13, OUTPUT);
  pinMode(2, INPUT_PULLUP);
  pinMode(3, INPUT_PULLUP);
  pinMode(4, INPUT_PULLUP);

  // debug output at 115200 baud
  SERIAL.begin(115200);
  //while (!SERIAL);


  // setup SD-card
  SERIAL.print("Initializing SD card...");
  if (!SD.begin(YOUR_SD_CS)) {
    SERIAL.println(" failed!");
    return;
  }

  SERIAL.println(" done.");

  AudioPlayer.begin(sampleRate);
  AudioPlayer.play(filename, 0);

  SERIAL.println("Playing file.....");
}

void loop()
{
  if (millis() - timer > 500) {
    //I'm working late at night, full led brightness is dazzling!
    //digitalWrite(13,state);
    analogWrite(13, state ? 0 : 4);

    state = !state;
    timer = millis();
  }


  if (SERIAL.available()) {
    char c = SERIAL.read();

    if ( c == 'a') {
      AudioPlayer.play("FXA.wav", 0);
    }
    else if ( c == 'A') {
      AudioPlayer.play("FXA.wav", 1);
    }
    else if ( c == 's') {
      AudioPlayer.play("TRACKS.wav", 2);
    }
    else if ( c == 'S') {
      AudioPlayer.play("TRACKS.wav", 3);
    }

    else if ( c == '0') {
      AudioPlayer.stopChannel(0);
      SERIAL.println("ch1 off!");
    }
    else if ( c == '1') {
      AudioPlayer.stopChannel(1);
      SERIAL.println("ch2 off!");
    }
    else if ( c == '2') {
      AudioPlayer.stopChannel(2);
      SERIAL.println("ch3 off!");
    }
    else if ( c == '3') {
      AudioPlayer.stopChannel(3);
      SERIAL.println("ch4 off!");
    }
  }

}
